/* misc.c
 * Declarations of various functions, mostly for logging, and some stuff
 * those functions need.
 */

#define LOGMODE_SYSL 	0x0001
#define LOGMODE_FILE 	0x0002
#define LOGMODE_STDOUT 	0x0004
#define NLMODE_SYSL 	0x0010
#define NLMODE_FILE 	0x0020
#define NLMODE_STDOUT 	0x0040

#define SetLSysL(x)	(x |= LOGMODE_SYSL)
#define SetLFile(x)	(x |= LOGMODE_FILE)
#define SetLSOut(x)	(x |= LOGMODE_STDOUT)

#define ClrLSysL(x)	(x &= ~LOGMODE_SYSL)
#define ClrLFile(x)	(x &= ~LOGMODE_FILE)
#define ClrLSOut(x)	(x &= ~LOGMODE_STDOUT)

#define HasLSysL(x)	(x & LOGMODE_SYSL)
#define HasLFile(x)	(x & LOGMODE_FILE)
#define HasLSOut(x)	(x & LOGMODE_STDOUT)

#define SetNSysL(x)	(x |= NLMODE_SYSL)
#define SetNFile(x)	(x |= NLMODE_FILE)
#define SetNSOut(x)	(x |= NLMODE_STDOUT)

#define ClrNSysL(x)	(x &= ~NLMODE_SYSL)
#define ClrNFile(x)	(x &= ~NLMODE_FILE)
#define ClrNSOut(x)	(x &= ~NLMODE_STDOUT)

#define HasNSysL(x)	(x & NLMODE_SYSL)
#define HasNFile(x)	(x & NLMODE_FILE)
#define HasNSOut(x)	(x & NLMODE_STDOUT)

#define HasSysL(x)	(x & (NLMODE_SYSL|LOGMODE_SYSL))
#define HasFile(x)	(x & (NLMODE_FILE|LOGMODE_FILE))
#define HasSOut(x)	(x & (NLMODE_STDOUT|LOGMODE_STDOUT))

#define MAX_LOG_BUFFER 1024

/* variables */
extern int errno, sys_nerr;

/* function declarations */
#ifdef NEEDSTRERROR
#if !defined(__GLIBC__) || (__GLIBC__ < 2)
extern char *sys_errlist[];
extern char *strerror(int);
#endif
#endif

extern void print_log(const char *, ...)
    __attribute__ ((format(printf, 1, 2)));
extern void print_log_err(const char *, ...)
    __attribute__ ((format(printf, 1, 2)));
extern void printb_log(int, char *);
extern void print_log_add(char *initmsg, ...)
    __attribute__ ((format(printf, 1, 2)));
extern void printb_log_add(char *);

extern char * hostlookup(unsigned long int);
extern char * servlookup(unsigned short, int);
