/* weedlog.h
 * The main header for weedlog.
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <time.h>
#include <signal.h>
#include <fcntl.h>
#include <syslog.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <ctype.h>
#include <arpa/inet.h>
#include <netdb.h>

#ifdef USETHREADS
#include <pthread.h>
#endif

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

typedef void *(*thread_function_t)(void *);

#include "match.h"
#include "misc.h"
#include "sockets.h"
#include "parse.h"

#ifndef VERSION
#define VERSION "1.0.1pl1"
#endif

#ifndef PATH_MAX
#define PATH_MAX 4095
#endif

#ifndef LOOPDELAY
#define LOOPDELAY 50
#endif

#ifndef MAXTHREADS
#define MAXTHREADS 10
#endif

int logmode, wlpid, debug, skipdns, skipport, dots;
char *progname;
int outfile;
#ifdef USETHREADS
int filelock, stdlock, activethreads;
#endif
